#define reply jsdhfjsdfjh
#define lreply skjdhjsdhfj
#include "ftpd.c"

#undef reply
#undef lreply
extern void reply();
extern void lreply();


#include <sys/time.h>


#if	!defined(USG) && !defined(SYSV) && !defined(SVR4) && !defined(__osf__)
# include "ftw.h"
#else
# include <ftw.h>
#endif

#if	defined(SVR4) || defined(SYSV) || defined(USG) || defined(USE_GETCWD)
# define getwd(str) getcwd(str,sizeof(str))
extern char *getcwd();
#else
extern char *getwd();
#endif

#ifdef	ISC
void
ftruncate(fd,offset)
     int fd;
     off_t offset;
{
	 /* Umm...  There is some ioctl()/fcntl() to do this.. */
}
#endif

void
fatal(s)
	char *s;
{
	reply(451, "Error in server: %s\n", s);
	reply(221, "Closing connection due to server error.");
	dologout(0);
	/* NOTREACHED */
}


/* Buffer these replies plenty,  Some clients don't like
   responces which arrive in multiple writes...
   (well, we can't do a thing about fragmentation...)  */

static char ReplyBuf[4];
static int  ReplyBufFill = 0;

/* VARARGS2 */
void
reply(va_alist)
	va_dcl
{
	char line[1024];
	int len;
	int n;
	char *fmt;
	va_list pvar;

	va_start(pvar);
	n = va_arg(pvar,int);

	if (autospout != NULL) {
		char *ptr = autospout;

		printf("%d-", n);
		while (*ptr) {
			if (*ptr == '\n') {
				printf("\r\n");
				if (*(++ptr))
					printf("%d-", n);
			} else {
				putchar(*ptr++);
			}
		}
		if (*(--ptr) != '\n')
			printf("\r\n");
		if (autospout_free) {
			(void) free(autospout);
			autospout_free = 0;
		}
		autospout = 0;
	}
	if (n<0) sprintf(line,"    ");
	else     sprintf(line,"%03d ", n);
	fmt = va_arg(pvar,char *);
	vsprintf(line+4,fmt,pvar);
	va_end(pvar);
	if (debug)
	  syslog(LOG_DEBUG, "<--- %s",line);
	strcat(line,"\r\n");
	len = strlen( line );
	if (len+ReplyBufFill < sizeof ReplyBuf) {
	  strcpy(ReplyBuf+ReplyBufFill,line);
	  ReplyBufFill += len;
	  fputs(ReplyBuf,stdout);
	  fflush(stdout);
	  cumul_cmd_bytes += ReplyBufFill;
	  ReplyBufFill = 0;
	} else {
	  if (ReplyBufFill > 0)
	    fputs(ReplyBuf,stdout);
	  cumul_cmd_bytes += ReplyBufFill + len;
	  ReplyBufFill = 0;
	  fputs(line,stdout);
	  fflush(stdout);
	}
}

/* VARARGS2 */
void
lreply(va_alist)
	va_dcl
{
	char line[1024];
	int len;
	int n;
	char *fmt;
	va_list pvar;

	if (!no_lreply) {
	  va_start(pvar);
	  n   = va_arg(pvar, int);
	  fmt = va_arg(pvar, char *);
	  if (n<0) sprintf(line,"   -");
	  else     sprintf(line,"%03d-", n);
	  vsprintf(line+4, fmt, pvar);
	  va_end(pvar);

	  if (debug)
	    syslog(LOG_DEBUG, "<--- %s",line);
	  strcat(line,"\r\n");
	  len = strlen( line );
	  if (len+ReplyBufFill < sizeof ReplyBuf) {
	    strcpy(ReplyBuf+ReplyBufFill,line);
	    ReplyBufFill += len;
	  } else {
	    if (ReplyBufFill > 0)
	      fputs(ReplyBuf,stdout);
	    cumul_cmd_bytes += ReplyBufFill;
	    ReplyBufFill = 0;
	    fputs(line,stdout);
	    (void)fflush(stdout);
	  }
	}
}

void
lreplys(n, tmperr, title, prefix)
	int n;
	FILE *tmperr;
	char *title, *prefix;
{
	char line[1024];
	char *s;
	int lines = 0;

	if (!tmperr) return;		/* No file */
	fseek(tmperr,0,2);
	if (ftell(tmperr)==0) return;	/* Empty file */

	fseek(tmperr,0,0);
	while(!feof(tmperr) && !ferror(tmperr)) {
	  *line = 0;
	  if (fgets(line,sizeof(line)-1,tmperr) == NULL) return;
	  if (lines == 0)
	    lreply(n,"%s",title);
	  ++lines;
	  s = strchr(line,'\n');
	  if (s) *s = 0;
	  lreply(n,"%s %s",prefix,line);
	}
}

void
ack(s)
	char *s;
{
	reply(250, "%s command successful.", s);
}

void
nack(s)
	char *s;
{
	reply(502, "%s command not implemented.", s);
}

/* ARGSUSED */
void
yyerror(s)
	char *s;
{
	char *cp;

	if ((cp = strchr(cbuf,'\n')))
		*cp = '\0';
	reply(500, "'%s': command not understood.", cbuf);
}


void
cwd(path)
	char *path;
{
	char wpath[MAXPATHLEN +1], *s;
	extern char envPWD[];
	FILE *msg;
	extern int restrict_dir();
	
	prettypath(wpath,workpath,path);
#if 0
	if (guest && restrict_dir(path)) {
	     strcat(wpath, "/.restrict.motd");
	     if (msg = fopen(wpath, "r")) {
		  while (!feof(msg) && !ferror(msg)) {
		       if (fgets(wpath, sizeof(wpath)-1, msg) == NULL) break;
		       if (s=(char *)strchr(wpath,"\n")) *s = 0;
		       lreply(550, "%s", wpath);
		  }
		  fclose(msg);
	     }
	     perror_reply(550, wpath);
	     return;
	}
#endif
	if (chdir(wpath) < 0)
		perror_reply(550, wpath);
	else {
		strcpy(workpath,wpath);
		if (strncmp(workpath,"/disk",5)==0)
		  lreply(250, "Growl! DON'T REFER TO SPECIFIC PHYSICAL DISKS! THEY CAN BE MOVED AROUND!");

		/* Either name should work,  .message  is preferred */
		if ((msg = fopen(".message","r")) ||
		    (msg = fopen(".readme","r"))) {
		  while(!feof(msg)&&!ferror(msg)) {
		    if (fgets(wpath,sizeof(wpath)-1,msg) == NULL) break;
		    if ((s = (char*)strchr(wpath,'\n'))) *s = 0;
		    lreply(250, "%s",wpath);
		  }
		  fclose(msg);
		}
		ack("CWD");
		if (guest)
		  AccessLogging("W %d %s '%s'", getpid(), remotehostname, workpath);
	}
	sprintf(envPWD,"PWD=%s",workpath);
	/*putenv(envPWD); -- no need to redo once done in main() */
}

#if 0
int restrict_dir(path)
char *path;
{
     char pathbuffer[MAXPATHLEN+1], *dirptr=pathbuffer, *ptr;
     char current_pwd[MAXPATHLEN+1], filename[MAXPATHLEN+1];
     FILE *restrict_file;

/*   ptr = getwd (current_pwd); 
     strcpy(pathbuffer, path);
     while ((ptr=strchr (pathbuffer, '/')) != NULL && pathbuffer!=NULL) {
	  *ptr = '0';
	  strcpy (filename, dirptr);
	  strcat (filename, "/.restrict");
	  if (restrict_file = fopen (filename, "r")) {
	       fclose (restrict_file);
	  }
	  ...

UNFINISHED!	   */

     return (0);
}
#endif

void
canonicpath(wpath,workpath,path)
	char wpath[MAXPATHLEN +1];
	char workpath[MAXPATHLEN +1];
	char *path;
{     
	register char *s;
	char current_pwd[MAXPATHLEN+1];
	int rc;

	prettypath(wpath,workpath,path);
	s = strrchr(wpath,'/');
	if (s) {
	  *s = 0;
	  if (s == wpath) rc = chdir("/");
	  else		  rc = chdir(wpath);
	  *s = '/';
	} else            rc = chdir("/");

	if (rc == 0 && getwd(current_pwd) != NULL) {
	  if (s) strcat(current_pwd,s);
	  else   strcat(current_pwd,wpath);
	  strcpy(wpath,current_pwd);
	}
	/* NOTE: ruins current working-directory knowledge ! */
}

void
prettypath(wpath,workpath,path)
	char wpath[MAXPATHLEN +1];
	char workpath[MAXPATHLEN +1];
	char *path;
{     
	register char *s = path, *t, *u;

	if (!usecanonicpath) {
	  strcpy(wpath,path);	/* Use original path as is.. */
	  return;
	}

	strcpy(wpath,workpath);	/* Init the work buffer */

	if (*wpath == 0)	/* Make sure the root has its "/" */
	  strcpy(wpath,"/");
	if (*s == '/')		/* Prefix `/' means -> to the root! */
	  strcpy(wpath,"/");
	if (strncmp("/disk",s,5)==0) {
	  /* Refers to a PHYSICAL disk.  A NO-NO at nic.funet.fi */
	  strcpy(wpath,"/pub");
	  s = (char*) strchr(s+1,'/');
	}
	while (s && *s) {
	  if (*s == '/') { ++s; continue; } /* Spurious (double) "/" */
	  t = s+1;
	  if (*s == '.' && *t == 0) {
	    break;		/* "CWD .CR"  Hmph.. */
	  }
	  if (*s == '.' && *t == '/') {
	    s += 2; continue;   /* "CWD ./XX" Hmm.. */
	  }
	  if (*s == '.' && *t == '.') {
	    ++t;		/* "CWD ..XX" */
	    if (*t == '/' || *t == 0) {
	      s += 2; /* Past the ".." */
	      t = strrchr(wpath,'/'); /* "CWD ..CR", or "CWD ../XX" */
	      if (!t) /* Oops! */ {
		*wpath = 0; /* Zap it all the way */
		continue;
	      }
	      *t = 0; /* Zap the last "/"  Only root has no dir name after the "/" */
	      if (*wpath == 0)	/* Make sure the root has its "/" after previous :-) */
		strcpy(wpath,"/");
	      continue;	/* Past that segment.. */
	    }
	    /* A normal file/directory starting with ".." ? */
	  }
	  /* Ok. "." and ".." processed.  Normal segments now. */
	  t = strchr(s,'/');
	  if (t) *t = 0; /* Zap the segment separator '/' */
	  u = wpath + strlen(wpath) -1;
	  if (u > wpath && *u != '/') 
	    strcat(++u,"/");	/* Append "/" if last we are not at the root */
	  strcat(++u,s);	/* Copy the segment */
	  if (t && *(t+1) != 0)
	    strcat(++u,"/");	/* If `/' wasn't last char, append it too */
	  if (t) s = t+1; else s = NULL;
	  			/* And terminate if it was last */
	} /* while (s && *s) */
	if (*wpath == 0)	/* Make sure the root has its "/" */
	  strcpy(wpath,"/");
}

void
pwd()
{
	char path[MAXPATHLEN +1];

	if (!usecanonicpath) {
		errno = 0;
		if( getwd(path) == NULL)
			reply(550, ". No path - errno=%x", errno);
		else
			reply(257, "\"%s\" is the current directory.", path);
	} else
		reply(257, "\"%s\" is the current directory.",
		      *workpath ? workpath : "/");
}

char *
renamefrom(name)
	char *name;
{
	struct stat64 st;

	if (lstat64(name, &st) < 0) {
		perror_reply(550, name);
		return ((char *)0);
	}
	reply(350, "File exists, ready for destination name");
	return (name);
}

void
renamecmd(from, to)
	char *from, *to;
{
	if (rename(from, to) < 0)
		perror_reply(550, "rename");
	else
		ack("RNTO");
}

void
dolog(sin)
	struct sockaddr_in *sin;
{
	struct hostent *hp = gethostbyaddr((char *)&sin->sin_addr,
					   sizeof (struct in_addr), AF_INET);

	if (hp)
		(void) strncpy(remotehost, hp->h_name, sizeof (remotehost));
	else
		(void) strncpy(remotehost, inet_ntoa(sin->sin_addr),
			       sizeof (remotehost));
#ifdef SETPROCTITLE
	sprintf(proctitle, "%s: connected", remotehost);
	setproctitle(proctitle);
#endif /* SETPROCTITLE */

	if (logging) {
		syslog(FTP_LOG_PRIORITY, "connection from %s",remotehost);
	}
}

/*
 * Record logout in wtmp file
 * and exit with supplied status.
 */
void
dologout(status)
int status;
{
     extern time_t login_time;
     time_t current_time;

     cumul_bytes += byte_count;
     byte_count = 0;

     if (logged_in) {
	  time (&current_time);
	  if (current_time == login_time)
	    ++current_time;
	  AccessLogging("O %d %s %d %ld", getpid(), remotehostname, cumul_bytes, current_time-login_time);
	  (void) seteuid((uid_t)0);
#ifdef DO_SYSLOG_VERBOSE
	  syslog(FTP_LOG_PRIORITY,
		 "logout of %s (%s:%s) with %d bytes sent, average %d Bps.",
		 remotehost, remotehostname, ftmppasswd, cumul_bytes,
		 cumul_bytes/(current_time-login_time));
#endif
	  logwtmp(ttyline, "", "");
     }	
     if (!logged_in || guest) {
#if 0
       endftmp(gttyline,ftmppasswd,remotehost,custlocality,NULL);
#else
       endftmp();
#endif
     }
     

     closelog();

     /* beware of flushing buffers after a SIGPIPE */
     _exit(status);
}

void myoob()
{
	char *cp;

	/* only process if transfer occurring */
	if (!transflag)
		return;
	cp = tmpline;
	if (getline(cp, 7, stdin) == NULL) {
		reply(221, "You could at least say goodbye.");
		dologout(0);
	}
	upper(cp);
	if (strcmp(cp, "ABOR\r\n") == 0) {
		tmpline[0] = '\0';
		reply(426, "Transfer aborted. Data connection closed.");
		reply(226, "Abort successful");
		longjmp(urgcatch, 1);
	}
	if (strcmp(cp, "STAT\r\n") == 0) {
		if (file_size != (off_t) -1)
			reply(213, "Status: %lu of %lu bytes transferred",
			    byte_count, file_size);
		else
			reply(213, "Status: %lu bytes transferred", byte_count);
	}
}

/*
 * Note: a response of 425 is not mentioned as a possible response to
 * 	the PASV command in RFC959. However, it has been blessed as
 * 	a legitimate response by Jon Postel in a telephone conversation
 *	with Rick Adams on 25 Jan 89.
 */
void
passive(vers)
int vers;
{
	int len;
	register char *p, *a;

	if (pw == NULL) {
	  perror_reply(425, "Not logged in properly.  Won't do passive");
	  return;
	}
	pdata = socket(AF_INET, SOCK_STREAM, 0);
	if (pdata < 0) {
		perror_reply(425, "Can't open passive connection");
		return;
	}
	pasv_addr = ctrl_addr;
	pasv_addr.sin_port = 0;
	(void) seteuid((uid_t)0);
	if (bind(pdata,
		 (struct sockaddr *)&pasv_addr, sizeof(pasv_addr)) < 0) {
		(void) seteuid(user_uid);
		goto pasv_error;
	}
	(void) seteuid(user_uid);
	len = sizeof(pasv_addr);
	if (getsockname(pdata, (struct sockaddr *) &pasv_addr, &len) < 0)
		goto pasv_error;
	if (listen(pdata, 1) < 0)
		goto pasv_error;
	a = (char *) &pasv_addr.sin_addr;
	p = (char *) &pasv_addr.sin_port;

#define UC(b) (((int) b) & 0xff)

	reply(227, "Entering Passive Mode (%d,%d,%d,%d,%d,%d)", UC(a[0]),
		UC(a[1]), UC(a[2]), UC(a[3]), UC(p[0]), UC(p[1]));
	return;

pasv_error:
	(void) close(pdata);
	pdata = -1;
	perror_reply(425, "Can't open passive connection");
	return;
}


/*
 * Format and send reply containing system error number.
 */
void
perror_reply(code, string)
	int code;
	char *string;
{
	va_list pvar;
	if (errno < sys_nerr)
		reply(code, "%s: %s.", string, strerror(errno));
	else
		reply(code, "%s: unknown error %d.", string, errno);
}

static char *onefile[] = {
	"",
	0
};

void
send_file_list(whichfiles)
	char *whichfiles;
{
	struct stat64 st;
	DIR *dirp = NULL;
	struct direct *dir;
	FILE *dout = NULL;
	register char **dirlist, *dirname;
	char *strpbrk();

#if 0
	if (guest) {
#endif
		retrieve(NLSTcmdstr, whichfiles);
		/* Option -P here together with environment FTPD_LS
		   gets a "print-path" action from the freak  /bin/ls
		   that we use.. */
		return;
#if 0
	}

	if (strpbrk(whichfiles, "~{[*?") != NULL) {
		extern char **glob(), *globerr;

		globerr = NULL;
		dirlist = glob(whichfiles);
		if (globerr != NULL) {
			reply(550, globerr);
			return;
		} else if (dirlist == NULL) {
			errno = ENOENT;
			perror_reply(550, whichfiles);
			return;
		}
	} else {
		onefile[0] = whichfiles;
		dirlist = onefile;
	}

	if (setjmp(urgcatch)) {
		transflag = 0;
		if(dout != NULL)
		  fclose(dout);
		return;
	}
	while (dirname = *dirlist++) {
		if (lstat64(dirname, &st) < 0) {
			/*
			 * If user typed "ls -l", etc, and the client
			 * used NLST, do what the user meant.
			 */
			if (dirname[0] == '-' && *dirlist == NULL &&
			    transflag == 0) {
				retrieve(NLSTcmdstr, dirname);
				return;
			}
			perror_reply(550, whichfiles);
			if (dout != NULL) {
				(void) fclose(dout);
				transflag = 0;
				data = -1;
				pdata = -1;
			}
			return;
		}

		if ((st.st_mode&S_IFMT) == S_IFREG) {
			if (dout == NULL) {
				dout = dataconn(whichfiles, (off_t)-1, "w");
				if (dout == NULL)
					return;
				transflag++;
			}
			fprintf(dout, "%s\n", dirname);
			byte_count += strlen(dirname) + 1;
			continue;
		} else if ((st.st_mode&S_IFMT) != S_IFDIR)
			continue;

		if ((dirp = opendir(*dirname == 0 ? "." : dirname)) == NULL)
			continue;

		while ((dir = readdir(dirp)) != NULL) {
			char nbuf[MAXPATHLEN];

#ifdef USG
			int dnamlen = strlen( dir->d_name );
			if (dir->d_name[0] == '.' && dnamlen == 1)
				continue;
			if (dir->d_name[0] == '.' && dir->d_name[1] == '.' &&
			    dnamlen == 2)
				continue;
#else
			if (dir->d_name[0] == '.' && dir->d_namlen == 1)
				continue;
			if (dir->d_name[0] == '.' && dir->d_name[1] == '.' &&
			    dir->d_namlen == 2)
				continue;
#endif

			sprintf(nbuf, "%s/%s", dirname, dir->d_name);

			/*
			 * We have to do a stat to insure it's
			 * not a directory or special file.
			 */
			if (lstat64(nbuf, &st) == 0 &&
			    (st.st_mode&S_IFMT) == S_IFREG) {
				if (dout == NULL) {
					dout = dataconn(whichfiles, (off_t)-1,
						"w");
					if (dout == NULL)
						return;
					transflag++;
				}
				if (nbuf[0] == '.' && nbuf[1] == '/')
					fprintf(dout, "%s\n", &nbuf[2]);
				else
					fprintf(dout, "%s\n", nbuf);
				byte_count += strlen(nbuf) + 1;
			}
		}
		(void) closedir(dirp);
	}

	if (dout == NULL)
		reply(550, "No files found.");
	else if (ferror(dout) != 0)
		perror_reply(550, "Data connection");
	else
		reply(226, "Transfer complete.");

	transflag = 0;
	if (dout != NULL)
		(void) fclose(dout);
	data = -1;
	pdata = -1;
#endif
}

#ifdef SETPROCTITLE
/*
 * clobber argv so ps will show what we're doing.
 * (stolen from sendmail)
 * warning, since this is usually started from inetd.conf, it
 * often doesn't have much of an environment or arglist to overwrite.
 */

static char *TitleTail = NULL;

/*VARARGS1*/
void
setproctitle(va_alist)
	va_dcl
{
	register char *p, *bp, ch;
	register int i;
	char *fmt;
	va_list pvar;
	char buf[BUFSIZ];

	va_start(pvar);
	fmt = va_arg(pvar,char *);
	vsprintf(buf, fmt, pvar);
	va_end(pvar);

	/* make ps print our process name */
	p = Argv[0];
	*p++ = '-';

	i = strlen(buf);
	if (i > LastArgv - p - 2) {
		i = LastArgv - p - 2;
		buf[i] = '\0';
	}
	bp = buf;
	while (ch = *bp++)
		if (ch != '\n' && ch != '\r')
			*p++ = ch;
	TitleTail = p;
	while (p < LastArgv)
		*p++ = ' ';
}
/*VARARGS1*/
void
appendproctitletail(va_alist)
	va_dcl
{
	register char *p, *bp, ch;
	register int i;
	char buf[BUFSIZ];
	char *fmt;
	va_list pvar;

	va_start(pvar);
	fmt = va_arg(pvar,char *);
	vsprintf(buf, fmt, pvar);
	va_end(pvar);

	p = TitleTail;
	i = strlen(buf);
	if (i > LastArgv - p - 2) {
		i = LastArgv - p - 2;
		buf[i] = '\0';
	}
	bp = buf;
	while (ch = *bp++)
		if (ch != '\n' && ch != '\r')
			*p++ = ch;
	TitleTail = p;
	while (p < LastArgv)
		*p++ = ' ';
}
/*VARARGS1*/
void
setproctitletail(va_alist)
	va_dcl
{
	register char *p, *bp, ch;
	register int i;
	char buf[BUFSIZ];
	char *fmt;
	va_list pvar;

	va_start(pvar);
	fmt = va_arg(pvar,char *);
	vsprintf(buf, fmt, pvar);
	va_end(pvar);

	p = TitleTail;
	i = strlen(buf);
	if (i > LastArgv - p - 2) {
		i = LastArgv - p - 2;
		buf[i] = '\0';
	}
	bp = buf;
	while (ch = *bp++)
		if (ch != '\n' && ch != '\r')
			*p++ = ch;
	while (p < LastArgv)
		*p++ = ' ';
}
#endif /* SETPROCTITLE */

#ifdef	free
void free_foo(){}
#endif

int
microsleep(delay)
long delay;
{
	struct timeval tv;

	tv.tv_sec  = delay / 1000000L;
	tv.tv_usec = delay % 1000000L;

	return select(0,NULL,NULL,NULL,&tv);
}



/*************************************************************************/
/* FUNCTION  : deny_badxfertype                                          */
/* PURPOSE   : If user is in ASCII transfer mode and tries to retrieve a */
/*             binary file, abort transfer and display appropriate error */
/* ARGUMENTS : message code to use for denial, path of file to check for */
/*             binary contents or NULL to assume binary file             */
/*************************************************************************/

int
deny_badasciixfer(msgcode, filepath)
int		msgcode;
char	*filepath;

{

   if (type == TYPE_A && !*filepath) {
      reply(msgcode, "This is a BINARY file, using ASCII mode to transfer will corrupt it.");
      return(1);
   }
   /* The hooks are here to prevent transfers of actual binary files, not
    * just TAR or COMPRESS mode files...
    */
   return(0);
}


static time_t newer_time;
static int show_fullinfo;
static FILE *dout;


void
newer(date, path, showlots)
char	*date, *path;
int		showlots;

{
	struct	tm tm;

	if (sscanf(date, "%04d%02d%02d%02d%02d%02d",
		   &tm.tm_year, &tm.tm_mon, &tm.tm_mday,
		   &tm.tm_hour, &tm.tm_min, &tm.tm_sec) == 6) {

	  tm.tm_year -= 1900;
	  tm.tm_mon--;
	  tm.tm_isdst = -1;
	  newer_time = mktime(&tm);
	  dout = dataconn("file list", (off_t)-1, "w", 0);
	  transflag++;
	  if (dout != NULL) {
	    int  check_newer();

	    show_fullinfo = showlots;
	    ftw(path, check_newer, -1);

	    if (ferror(dout) != 0)
	      perror_reply(550, "Data connection");
	    else
	      reply(226, "Transfer complete.");

	    (void) fclose(dout);
	    data = -1;
	  }
	} else
	  reply(501, "Bad DATE format");
	transflag = 0;
}

int
check_newer(path, st, flag)
char *path;
struct stat64 *st;
int flag;
{
	if (st->st_mtime > newer_time) {
	  if (show_fullinfo != 0) {
	    if (flag == FTW_F || flag == FTW_D) {
	      fprintf(dout, "%s %lld %ld %s", flag == FTW_F ? "F" : "D",
		      st->st_size, st->st_mtime, path);
	    }
	  } else if (flag == FTW_F) fprintf(dout, "%s", path);
	}
	return 0;
}

void
findpathcmd(cmdbuf,cmdstr)
char *cmdbuf;
const char *cmdstr;
{
	extern char *PATH;
	static char *Paths[30];
	char **P = Paths;

	if (*cmdstr == '/') {
	  strcpy(cmdbuf,cmdstr);
	  return;
	}

	if (PATH) {	/* Convert "/bin:/usr/bin:/usr/local/bin" to
			   "/bin","/usr/bin",...,NULL */
	  char *p = PATH;
	  while (*p) {
	    *P++ = p;
	    while (*p && *p != ':') ++p;
	    if (*p) *p++ = 0;
	  }
	  *P = NULL;
	  PATH = NULL;
	  P = Paths;
	}

	/* Apply paths, try to find the command */
	while (*P) {
	  char *s;
	  struct stat64 estat;
	  int rc;

	  sprintf(cmdbuf,"%s/%s",*P,cmdstr);
	  s = strchr(cmdbuf,' ');
	  if (s) *s = 0;
	  rc = lstat64(cmdbuf,&estat);
	  if (s) *s = ' ';
	  if (rc == 0) { /* This MAY be it, lets check ? */
	    return;
	  }
	  ++P;
	}
}

void
site_lsdbg()
{
	static int envexists = 0;
	static char envbuf[30];
	char *envstr = "FTPD_DEBUG=+D";

	if (envexists > 0)
		strcpy(envbuf,"FTPD_..=,,");
	else if (envexists < 0)
		strcpy(envbuf,envstr);
	else {
		strcpy(envbuf,envstr);
		putenv(envbuf);
		envexists = -1;
	}
	envexists =  -envexists;
	reply(250,"SITE LSBDG turned %s",envexists > 0? "ON":"OFF");
}

#ifdef SVR4
#include <sys/resource.h>
int getdtablesize()
{
  struct rlimit rl;
  int rc = getrlimit(RLIMIT_NOFILE,&rl);
  return rl.rlim_cur;
}
#endif
