# nicraw.awk
# ----------
# ftp:n raakaloki on tiedostoissa
# /p/log/ftp/raw/yymm/yymmdd.gz
#
# R-alkuiset rekordit kertovat siirretyist{ tiedostoista
# (niin ainakin Markus arveli 1.7.1993). T{ss{ oletetaan,
# vain ne on grepattu sy|tt|tiedoksi.
# 
# Kolmas kentt{ on k{ytt{j{n domain (tai ip-numero),
# nelj{s on hakemisto ('/pub/unix/..') ja viides siirretty
# tavum{{r{. (Toivottavasti arvaus meni oikein!)
#
# Tulostus kilotavuina!
#
/^R/	{
	ndom = split($3, domain, ".")
	ndir = split($4, direct, "/")
	if(direct[2] == "pub") {  # jotain jaa kylla pois...
		dirika = direct[3]
		if(substr(dirika, length(dirika)) == "'")
			dirika = substr(dirika, 1, length(dirika)-1)
		if(substr(domain[1], 1, 1) == "[") { ndom = 1; domain[ndom] = "unkn" }
		domaini = tolower(domain[ndom])
		domt[domaini] += $5
		dirt[dirika] += $5
		table[tolower(domaini) ":" dirika] += $5
	if(length(dirika)==1) print $0
	}
}  
END {
# kaksikymment{ suurinta domainia ja kaikki hakemistot aputiedostoihin
	for (i in domt) { printf("%10.0f %s\n", domt[i]/1000.0, i) | "sort -n | tail -20 > nicdom.tmp" }
	for (i in dirt) { printf("%10.0f %s\n", dirt[i]/1000.0, i) | "sort -n > nicdir.tmp" }
#
	for (i in table) {
	split(i, ii, ":")
	printf("%10.0f %s %s\n", table[i]/1000.0, ii[1], ii[2]) }
}
