#include "ftpd.c"


int
check_closure(dirprefix)
char *dirprefix;
{
	/* We check for closure of service for some reasons. Any reasons! */

	struct stat fstat;
	char *s;
	char line[BUFSIZ];
	FILE *CustMsgFd;

	if (dirprefix[1]==0 && dirprefix[0]=='/')
	  strcpy(line,FTPDCLOSED);
	else
	  sprintf(line,"%s%s",dirprefix,FTPDCLOSED);

	if(stat(line,&fstat)==0) {
	  CustMsgFd = fopen(line,"r");
	  if(CustMsgFd != NULL) {
	    fseek(CustMsgFd,0,0);
	    while(!ferror(CustMsgFd) && !feof(CustMsgFd)) {
	      *line = 0;
	      fgets(line,sizeof(line)-1,CustMsgFd);
	      if((s = (char*)strchr(line,'\n'))) *s= 0;
	      if(*line == 0) break;
	      lreply(421,"%s",line);
	    }
	  }
	  fclose(CustMsgFd);
	  reply(421,"Sorry, service closed for a while, try again later.");
	  end_login("Service closed for a while");
	  exit(0);
	}
	if(stat(NOLOGIN,&fstat)==0) {
	  CustMsgFd = fopen(NOLOGIN,"r");
	  if(CustMsgFd != NULL) {
	    fseek(CustMsgFd,0,0);
	    while(!ferror(CustMsgFd) && !feof(CustMsgFd)) {
	      *line = 0;
	      fgets(line,sizeof(line)-1,CustMsgFd);
	      if((s = (char*)strchr(line,'\n'))) *s= 0;
	      if(*line == 0) break;
	      lreply(421,"%s",line);
	    }
	  }
	  fclose(CustMsgFd);
	  reply(421,"Sorry, We are shutting down this system, try again once we are up again");
	  end_login("System shutting down");
	  exit(0);
	}
	return 0;
}
